<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCatchSeatsPerEventRequest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCatchSeatsPerEventRequest
 * @subpackage Arrays
 */
class ArrayOfCatchSeatsPerEventRequest extends AbstractStructArrayBase
{
    /**
     * The CatchSeatsPerEventRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\CatchSeatsPerEventRequest[]
     */
    public $CatchSeatsPerEventRequest;
    /**
     * Constructor method for ArrayOfCatchSeatsPerEventRequest
     * @uses ArrayOfCatchSeatsPerEventRequest::setCatchSeatsPerEventRequest()
     * @param \patest\StructType\CatchSeatsPerEventRequest[] $catchSeatsPerEventRequest
     */
    public function __construct(array $catchSeatsPerEventRequest = array())
    {
        $this
            ->setCatchSeatsPerEventRequest($catchSeatsPerEventRequest);
    }
    /**
     * Get CatchSeatsPerEventRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\CatchSeatsPerEventRequest[]|null
     */
    public function getCatchSeatsPerEventRequest()
    {
        return isset($this->CatchSeatsPerEventRequest) ? $this->CatchSeatsPerEventRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCatchSeatsPerEventRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCatchSeatsPerEventRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCatchSeatsPerEventRequestForArrayConstraintsFromSetCatchSeatsPerEventRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCatchSeatsPerEventRequestCatchSeatsPerEventRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfCatchSeatsPerEventRequestCatchSeatsPerEventRequestItem instanceof \patest\StructType\CatchSeatsPerEventRequest) {
                $invalidValues[] = is_object($arrayOfCatchSeatsPerEventRequestCatchSeatsPerEventRequestItem) ? get_class($arrayOfCatchSeatsPerEventRequestCatchSeatsPerEventRequestItem) : sprintf('%s(%s)', gettype($arrayOfCatchSeatsPerEventRequestCatchSeatsPerEventRequestItem), var_export($arrayOfCatchSeatsPerEventRequestCatchSeatsPerEventRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CatchSeatsPerEventRequest property can only contain items of type \patest\StructType\CatchSeatsPerEventRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CatchSeatsPerEventRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\CatchSeatsPerEventRequest[] $catchSeatsPerEventRequest
     * @return \patest\ArrayType\ArrayOfCatchSeatsPerEventRequest
     */
    public function setCatchSeatsPerEventRequest(array $catchSeatsPerEventRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($catchSeatsPerEventRequestArrayErrorMessage = self::validateCatchSeatsPerEventRequestForArrayConstraintsFromSetCatchSeatsPerEventRequest($catchSeatsPerEventRequest))) {
            throw new \InvalidArgumentException($catchSeatsPerEventRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($catchSeatsPerEventRequest) || (is_array($catchSeatsPerEventRequest) && empty($catchSeatsPerEventRequest))) {
            unset($this->CatchSeatsPerEventRequest);
        } else {
            $this->CatchSeatsPerEventRequest = $catchSeatsPerEventRequest;
        }
        return $this;
    }
    /**
     * Add item to CatchSeatsPerEventRequest value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\CatchSeatsPerEventRequest $item
     * @return \patest\ArrayType\ArrayOfCatchSeatsPerEventRequest
     */
    public function addToCatchSeatsPerEventRequest(\patest\StructType\CatchSeatsPerEventRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\CatchSeatsPerEventRequest) {
            throw new \InvalidArgumentException(sprintf('The CatchSeatsPerEventRequest property can only contain items of type \patest\StructType\CatchSeatsPerEventRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CatchSeatsPerEventRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\CatchSeatsPerEventRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\CatchSeatsPerEventRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\CatchSeatsPerEventRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\CatchSeatsPerEventRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\CatchSeatsPerEventRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CatchSeatsPerEventRequest
     */
    public function getAttributeName()
    {
        return 'CatchSeatsPerEventRequest';
    }
}
